'\"
'\" Copyright (c) 1992 The Regents of the University of California.
'\" Copyright (c) 1994-1995 Sun Microsystems, Inc.
'\"
'\" See the file "license.terms" for information on usage and redistribution
'\" of this file, and for a DISCLAIMER OF ALL WARRANTIES.
'\" 
'\" @(#) tk.n 1.10 95/06/22 14:08:44
'\" 
.so STk-man.macros
.TH tk n 3.1 STk "Tk Built-In Commands"
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
tk \- Manipulate Tk internal state
.SH SYNOPSIS
(\fBtk\fR \fIoption \fR?\fIarg arg ...\fR?)
.BE

.SH DESCRIPTION
.PP
The \fBtk\fR procedure provides access to miscellaneous
elements of Tk's internal state.
Most of the information manipulated by this procedure pertains to the
application as a whole, or to a screen or display, rather than to a
particular window.
The procedure can take any of a number of different forms
depending on the \fIoption\fR argument.  The legal forms are:
.TP
(\fBtk 'appname\fR)
.TP
(\fBtk 'appname \fInewName\fR)
If \fInewName\fR isn't specified, this procedure returns the name
of the application (the name that may be used in \fBsend\fR
procedures to communicate with the application).
If \fInewName\fR is specified, then the name of the application
is changed to \fInewName\fR.
If the given name is already in use, then a suffix of the form
``\fB #2\fR'' or ``\fB #3\fR'' is appended in order to make the name unique.
The procedure's result is the name actually chosen.
\fInewName\fR should not start with a capital letter.
This will interfere with option processing, since names starting with
capitals are assumed to be classes;  as a result, Tk may not
be able to find some options for the application.
If sends have been disabled by deleting the \fBsend\fR procedure,
(with \fBinhibit-send\fR) this procedure will reenable them and 
recreate the \fBsend\fR procedure.

.SH SEE ALSO
send
